diff -arcN emacs-18.55/src/x11fns.c nemacs-3.3.2/src/x11fns.c
*** emacs-18.55/src/x11fns.c	Mon Aug 14 04:54:21 1989
--- nemacs-3.3.2/src/x11fns.c	Wed Jun  6 03:18:42 1990
***************
*** 1,3 ****
--- 1,7 ----
+ /*           modified for Nemacs Ver.2.1  by A.Kato */
+ /*  89.3.13  modified for Nemacs Ver.3.0  by K.Handa */
+ /*  89.4.17  modified for Nemacs Ver.3.2.1 by T.Hasei */
+ 
  /* Functions for the X window system.
     Copyright (C) 1988 Free Software Foundation.
  
***************
*** 43,48 ****
--- 47,56 ----
  
  #ifdef HAVE_X_WINDOWS
  
+ #ifdef NEMACS
+ #include "kanji.h"
+ #endif
+ 
  #define abs(x) ((x < 0) ? ((x)) : (x))
  #define sgn(x) ((x < 0) ? (-1) : (1))
  #define min(a,b) ((a) < (b) ? (a) : (b))
***************
*** 85,90 ****
--- 93,105 ----
  extern GC XXgc_norm,XXgc_rev,XXgc_curs,XXgc_temp;
  extern XGCValues XXgcv;
  extern int XXfontw,XXfonth,XXbase,XXisColor;
+ #ifdef NEMACS
+ extern XFontStruct *wfontinfo;
+ extern Font XXWfid;
+ extern GC XXWgc_norm,XXWgc_rev,XXWgc_curs,XXWgc_temp;
+ extern XGCValues XXWgcv;
+ extern int XXWfontw,XXWfonth,XXWbase;
+ #endif  /* NEMACS */
  extern Colormap XXColorMap;
  
  extern int PendingExposure;
***************
*** 96,101 ****
--- 111,119 ----
  extern Cursor EmacsCursor;
  extern short MouseCursor[], MouseMask[];
  extern char *XXcurrentfont;
+ #ifdef	NEMACS
+ extern char *XXWcurrentfont;
+ #endif
  extern int informflag;
  
  extern int WindowMapped;
***************
*** 174,179 ****
--- 192,201 ----
  
  	XSetForeground(XXdisplay, XXgc_norm, fore);
  	XSetBackground(XXdisplay, XXgc_rev, fore);
+ #ifdef	NEMACS
+ 	XSetForeground(XXdisplay, XXWgc_norm, fore);
+ 	XSetBackground(XXdisplay, XXWgc_rev, fore);
+ #endif
  	
  	Fredraw_display ();
  	UNBLOCK_INPUT ();
***************
*** 215,224 ****
--- 237,255 ----
  
  	XSetBackground (XXdisplay, XXgc_norm, back);
  	XSetForeground (XXdisplay, XXgc_rev, back);
+ #ifdef	NEMACS
+  	XSetBackground (XXdisplay, XXWgc_norm, back);
+ 	XSetForeground (XXdisplay, XXWgc_rev, back);
+ #endif
  	XSetWindowBackground(XXdisplay, XXwindow, back);
  	XClearArea (XXdisplay, XXwindow, 0, 0,
  		    screen_width*XXfontw+2*XXInternalBorder,
  		    screen_height*XXfonth+2*XXInternalBorder, 0);
+ #ifdef	NEMACS
+ 	XClearArea (XXdisplay, XXwindow, 0, 0,
+ 		    screen_width*XXWfontw+2*XXInternalBorder,
+ 		    screen_height*XXWfonth+2*XXInternalBorder, 0);
+ #endif
  	
  	UNBLOCK_INPUT ();
  	Fredraw_display ();
***************
*** 300,305 ****
--- 331,339 ----
  				curs_color = save_color;
  
  	XSetBackground(XXdisplay, XXgc_curs, curs);
+ #ifdef	NEMACS
+ 	XSetBackground(XXdisplay, XXWgc_curs, curs);
+ #endif
  	
  	CursorToggle ();
  	CursorToggle ();
***************
*** 483,488 ****
--- 517,551 ----
  	return Qnil;
  }
  
+ #ifdef	NEMACS
+ DEFUN ("x-set-kfont", Fx_set_kfont, Sx_set_kfont, 1, 1, "sKanji Font Name: ",
+       "Sets the kanji font to be used for the X window.")
+   (arg)
+      Lisp_Object arg;
+ {
+ 	register char *newfontname;
+ 	
+ 	CHECK_STRING (arg, 1);
+ 	check_xterm ();
+ 
+ 	newfontname = (char *) xmalloc (XSTRING (arg)->size + 1);
+ 	bcopy (XSTRING (arg)->data, newfontname, XSTRING (arg)->size + 1);
+ 	if (XSTRING (arg)->size == 0)
+ 		goto badfont;
+ 
+ 	if (!/*XNewFont*/ XNewWFont (newfontname)) {
+ 		free (/*XXcurrentfont*/ XXWcurrentfont);
+ 		/*XXcurrentfont*/ XXWcurrentfont = newfontname;
+ 		return Qt;
+ 	}
+ badfont:
+ 	error ("Kanji font \"%s\" is not defined", newfontname);
+ 	free (newfontname);
+ 
+ 	return Qnil;
+ }
+ #endif	/* NEMACS */
+ 
  DEFUN ("coordinates-in-window-p", Fcoordinates_in_window_p,
    Scoordinates_in_window_p, 2, 2, 0,
    "Return non-nil if POSITIONS (a list, (SCREEN-X SCREEN-Y)) is in WINDOW.\n\
***************
*** 640,645 ****
--- 703,719 ----
  	return Qnil;
  }
  
+ #ifdef	NEMACS
+ 	/*
+ 	 * Code conversion is necessary when x-store-cut-buffer and
+ 	 * x-get-cut-buffer operation is executed. Due to the
+ 	 * (temporaly) convention of kterm, all strings in the cut
+ 	 * buffers in a X server should be represented in 7bit JIS
+ 	 * code regardless of the native Kanji code. So we put e2j()
+ 	 * and j2e() to do code conversion. Those modifications are
+ 	 * done by kato@cs.titech.junet.
+ 	 */
+ #endif	/* NEMACS */
  DEFUN ("x-store-cut-buffer", Fx_store_cut_buffer, Sx_store_cut_buffer,
    1, 1, "sSend string to X:",
    "Store contents of STRING into the cut buffer of the X window system.")
***************
*** 646,651 ****
--- 720,729 ----
    (string)
       register Lisp_Object string;
  {
+ #ifdef	NEMACS
+ 	int len;
+ 	unsigned char *p;
+ #endif	/* NEMACS */
  	BLOCK_INPUT_DECLARE ();
  
  	CHECK_STRING (string, 1);
***************
*** 652,659 ****
--- 730,747 ----
  	check_xterm ();
  
  	BLOCK_INPUT ();
+ #ifdef	NEMACS
+ 	p = (unsigned char *)malloc(XSTRING (string)->size * 3 + 5);
+ 	if (!p)
+ 		memory_full();
+ 	len = e2j(XSTRING (string)->size, XSTRING (string)->data, p,
+ 		XFASTINT(to_kanji_fileio), XFASTINT(to_ascii_fileio));
+ 	XStoreBytes (XXdisplay, p, len);
+ 	free(p);
+ #else	/* not NEMACS */
  	XStoreBytes (XXdisplay, XSTRING (string)->data,
  		     XSTRING (string)->size);
+ #endif	/* not NEMACS */
  	UNBLOCK_INPUT ();
  
  	return Qnil;
***************
*** 666,676 ****
--- 754,780 ----
  	int len;
  	register Lisp_Object string;
  	BLOCK_INPUT_DECLARE ();
+ #ifdef	NEMACS
+ 	register unsigned char *p;
+ #endif	/* NEMACS */
  	register char *d;
  
  	BLOCK_INPUT ();
  	d = XFetchBytes (XXdisplay, &len);
+ #ifdef	NEMACS
+ 	if (len <= 0)
+ 		string = make_string ("", len);
+ 	else {
+ 		p = (unsigned char *)malloc(len + 1);
+ 		if (!p)
+ 			memory_full();
+ 		len = j2e(len, d, p);
+ 		string = make_string (p, len);
+ 		free(p);
+ 	}
+ #else	/* not NEMACS */
  	string = make_string (d, len);
+ #endif	/* not NEMACS */
  	UNBLOCK_INPUT ();
  
  	return string;
***************
*** 864,869 ****
--- 968,976 ----
    defsubr (&Sx_set_bell);
    defsubr (&Sx_flip_color);
    defsubr (&Sx_set_font);
+ #ifdef	NEMACS
+   defsubr (&Sx_set_kfont);
+ #endif
  #ifdef notdef
    defsubr (&Sx_set_icon);
  #endif notdef
diff -arcN emacs-18.55/src/x11term.c nemacs-3.3.2/src/x11term.c
*** emacs-18.55/src/x11term.c	Thu Aug  3 11:56:42 1989
--- nemacs-3.3.2/src/x11term.c	Wed Jun  6 03:18:44 1990
***************
*** 1,3 ****
--- 1,16 ----
+ /*          modified for Nemacs Ver.2.1 by A.Kato */
+ /* 89.3.13  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.11.24 modified for attribute of characters by K.Handa */
+ /* 89.12.12 modified for Nemacs Ver.3.2.1 by K.Handa
+ 	- GR encoded Japanese fonts (MSB=1) can be used.
+ 	- Calculation of width and height of fonts are changed.
+ 	- Underline is drawn by GXcopy or GXcopyInverted. */
+ /* 89.12.15 modified for Nemacs Ver.3.2.1 by T.Hasei */
+ /* 89.12.19 modified for Nemacs Ver.3.2.3 by K.Handa
+ 	- Underline is drawn by GXset or GXclear. */
+ /* 90.3.26  modified for Nemacs Ver.3.3.2 by Ishisone
+ 	- GC for underline is changed. */
+ 
  /* X Communication module for terminals which understand the X protocol.
     Copyright (C) 1988 Free Software Foundation, Inc.
  
***************
*** 124,129 ****
--- 137,152 ----
  XFontStruct *fontinfo;
  Font XXfid;
  int XXfontw, XXfonth, XXbase, XXisColor;
+ #ifdef	NEMACS
+ char *XXWcurrentfont;
+ XFontStruct *wfontinfo;
+ Font XXWfid;
+ int XXWfontw, XXWfonth, XXWbase;
+ int  XXfonthBounds;
+ /* 89.12.11  patch by K.Handa */
+ int XXWhighencoding, XXWul_descent, XXul_descent;
+ /* end of patch */
+ #endif	NEMACS
  
  Colormap XXColorMap;
  char *default_window;
***************
*** 172,177 ****
--- 195,204 ----
  Window XXwindow;
  GC XXgc_norm,XXgc_rev,XXgc_curs,XXgc_temp;
  XGCValues XXgcv;
+ #ifdef	NEMACS
+ GC XXWgc_norm,XXWgc_rev,XXWgc_curs,XXWgc_temp;
+ XGCValues XXWgcv;
+ #endif
  Cursor EmacsCursor;
  Pixmap SinkPixmap, SinkMaskPixmap;
  
***************
*** 195,200 ****
--- 222,230 ----
  int updated[MAXHEIGHT];
  
  static char  *temp_font;                /* needed because of loading hacks */
+ #ifdef	NEMACS
+ static char  *temp_wfont;                /* needed because of loading hacks */
+ #endif	NEMACS
  static char  *temp_reverseVideo;
  static char  *temp_borderWidth;
  static char  *temp_internalBorder;
***************
*** 217,222 ****
--- 247,256 ----
       { "pointerColor",	"Foreground",		&mous_color },
       { "cursorColor",	"Foreground",		&curs_color },
       { "font",		"Font",			&temp_font },
+ #ifdef	NEMACS
+      { "kfont",		"KanjiFont",		&temp_wfont },
+      { "kfont",		"kanjiFont",		&temp_wfont }, /* by T.Hasei */
+ #endif	NEMACS
       { "geometry",	"Geometry",		&desiredwindow },
       { "title",		"Title",		&XXheader },
       { "iconName",	"Title",		&XXicon_name },
***************
*** 476,482 ****
--- 510,534 ----
  	    tempY < 0 || tempY >= screen_height)
  		return;
  
+ #ifdef	NEMACS
+ 	if (ActiveScreen[tempY+1]->body[tempX] & 0x80) {
+ 		unsigned char	*p =
+ 			(unsigned char *) ActiveScreen[tempY+1]->body;
+ 		int	i, flag;
+ 
+ 		for (flag = i = 0 ; i < tempX ; i++, p++)
+ 			if (flag = *p & 0x80)
+ 				i++, p++;
+ 		if (flag && i > tempX)
+ 			tempX--, numcols++;
+ 	}
+ 	XDrawEUC(XXdisplay, XXwindow, tempHL ? XXgc_rev : XXgc_norm,
+ 				      tempHL ? XXWgc_rev : XXWgc_norm,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 		         &ActiveScreen[tempY+1]->attribute[tempX],
+ #else	NEMACS
  	XDrawImageString(XXdisplay, XXwindow, tempHL ? XXgc_rev : XXgc_norm,
+ #endif	NEMACS
  			 tempX*XXfontw+XXInternalBorder,
  			 tempY*XXfonth+XXInternalBorder+XXbase,
  			 &ActiveScreen[tempY+1]->body[tempX],
***************
*** 518,525 ****
--- 570,585 ----
  	else
  		temp_length = 0;
  	if (temp_length > 0) {
+ #ifdef	NEMACS
+ 		XDrawEUC (XXdisplay, XXwindow,
+ 				  CurHL ? XXgc_rev : XXgc_norm,
+ 				  CurHL ? XXWgc_rev : XXWgc_norm,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 				  &DesiredScreen[cursY + 1]->attribute[first],
+ #else	NEMACS
  		XDrawImageString (XXdisplay, XXwindow,
  				  CurHL ? XXgc_rev : XXgc_norm,
+ #endif	NEMACS
  				  first*XXfontw+XXInternalBorder,
  				  cursY*XXfonth+XXInternalBorder+XXbase,
  				  &DesiredScreen[cursY + 1]->body[first],
***************
*** 540,545 ****
--- 600,609 ----
  {
    BLOCK_INPUT_DECLARE ();
  
+ /* patch by K.Handa for highlight */
+ /*  updateline(0); return;
+ /* end of patch */
+ 
  #ifdef XDEBUG
    fprintf(stderr, "writechars (cursX %d temp_len %d InUpd %d)\n",
  	  cursX, end-start+1, InUpdate);
***************
*** 556,566 ****
--- 620,640 ----
    if (CursorExists)
      CursorToggle ();
  
+ /* patch by K.Handa for highlight */
+   if (inverse_video) HLmode(1);
  
    if (InUpdate)
      {
+ #ifdef	NEMACS
+       XDrawEUC (XXdisplay, XXwindow,
+ 			CurHL ? XXgc_rev : XXgc_norm,
+ 			CurHL ? XXWgc_rev : XXWgc_norm,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 		        attribute_p,
+ #else	NEMACS
        XDrawImageString (XXdisplay, XXwindow,
  			CurHL ? XXgc_rev : XXgc_norm,
+ #endif	NEMACS
  			cursX*XXfontw+XXInternalBorder,
  			cursY*XXfonth+XXInternalBorder+XXbase,
  			start,
***************
*** 582,589 ****
--- 656,671 ----
    if (((end - start) + VisibleX) >= screen_width)
      end = start + (screen_width - (VisibleX + 1));
    if (end >= start) {
+ #ifdef	NEMACS
+     XDrawEUC (XXdisplay, XXwindow,
+ 		      CurHL ? XXgc_rev : XXgc_norm,
+ 		      CurHL ? XXWgc_rev : XXWgc_norm,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 	              attribute_p,
+ #else	NEMACS
      XDrawImageString (XXdisplay, XXwindow,
  		      CurHL ? XXgc_rev : XXgc_norm,
+ #endif	NEMACS
  		      (VisibleX * XXfontw+XXInternalBorder),
  		      VisibleY * XXfonth+XXInternalBorder+XXbase,
  		      start,
***************
*** 692,704 ****
--- 774,798 ----
  	if (ActiveScreen && ActiveScreen[VisibleY+1] &&
  	    VisibleX < ActiveScreen[VisibleY+1]->length) {
  		if (CursorExists)
+ #ifdef	NEMACS
+ 			XDrawEUC(XXdisplay, XXwindow, XXgc_norm, XXWgc_norm,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 				&ActiveScreen[VisibleY+1]->attribute[VisibleX],
+ #else
  			XDrawImageString(XXdisplay, XXwindow, XXgc_norm,
+ #endif
  				    VisibleX*XXfontw+XXInternalBorder,
  				    VisibleY*XXfonth+XXInternalBorder+XXbase,
  				    &ActiveScreen[VisibleY+1]->body[VisibleX],
  				    1);
  		else if (CursorOutline) {
+ #ifdef	NEMACS
+ 			XDrawEUC(XXdisplay, XXwindow, XXgc_norm, XXWgc_norm,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 				&ActiveScreen[VisibleY+1]->attribute[VisibleX],
+ #else
  			XDrawImageString(XXdisplay, XXwindow, XXgc_norm,
+ #endif
  				    VisibleX*XXfontw+XXInternalBorder,
  				    VisibleY*XXfonth+XXInternalBorder+XXbase,
  				    &ActiveScreen[VisibleY+1]->body[VisibleX],
***************
*** 706,714 ****
--- 800,818 ----
  			XDrawRectangle (XXdisplay, XXwindow, XXgc_norm,
  					VisibleX*XXfontw+XXInternalBorder,
  					VisibleY*XXfonth+XXInternalBorder,
+ #ifdef	NEMACS
+ 					XXfontw*((ActiveScreen[VisibleY+1]->body[VisibleX]) & 0x80 ? 2 : 1) - 1, XXfonth - 1);
+ #else
  					XXfontw - 1, XXfonth - 1);
+ #endif
  		} else
+ #ifdef	NEMACS
+ 			XDrawEUC(XXdisplay, XXwindow, XXgc_curs, XXWgc_curs,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 				&ActiveScreen[VisibleY+1]->attribute[VisibleX],
+ #else
  			XDrawImageString(XXdisplay, XXwindow, XXgc_curs,
+ #endif
  				    VisibleX*XXfontw+XXInternalBorder,
  				    VisibleY*XXfonth+XXInternalBorder+XXbase,
  				    &ActiveScreen[VisibleY+1]->body[VisibleX],
***************
*** 719,725 ****
--- 823,833 ----
  			XClearArea (XXdisplay, XXwindow,
  				    VisibleX*XXfontw+XXInternalBorder,
  				    VisibleY*XXfonth+XXInternalBorder,
+ #ifdef NEMACS  /* 89.11.28  by K.Handa */
+ 				    XXfontw*2, XXfonth, 0);
+ #else
  				    XXfontw, XXfonth, 0);
+ #endif
  		else if (CursorOutline)
  			XDrawRectangle (XXdisplay, XXwindow, XXgc_norm,
   					VisibleX*XXfontw+XXInternalBorder,
***************
*** 726,732 ****
--- 834,846 ----
  					VisibleY*XXfonth+XXInternalBorder,
  					XXfontw - 1, XXfonth - 1);
  		else
+ #ifdef	NEMACS
+ 			XDrawEUC(XXdisplay, XXwindow, XXgc_curs, XXWgc_curs,
+ /* patch for attribute by K.Handa  89.11.24 */
+ 				    "\0",
+ #else
  			XDrawImageString(XXdisplay, XXwindow, XXgc_curs,
+ #endif
  				    VisibleX*XXfontw+XXInternalBorder,
  				    VisibleY*XXfonth+XXInternalBorder+XXbase,
  				    " ", 1);
***************
*** 1598,1603 ****
--- 1712,1720 ----
  
  	desiredwindow =
  	XXcurrentfont =
+ #ifdef	NEMACS
+ 	XXWcurrentfont =
+ #endif	NEMACS
  	XXidentity =
  	XXicon_name =
  	XXheader = (char *) NULL;
***************
*** 1604,1610 ****
--- 1721,1734 ----
  
  	XXicon_usebitmap = 0;
  	
+ #ifdef	NEMACS  /* modified by K.Handa 89.12.12 */
+ 	temp_font = "a14";
+ 	temp_wfont = "k14";
+ 	XXfonth = XXfontw = XXbase = XXWfonth = XXWfontw = XXWbase = 0;
+ 	XXul_descent = XXWul_descent = 0;
+ #else	NEMACS
  	temp_font = "fixed";
+ #endif	NEMACS
  	progname = xargv[0];
  	if (ptr = rindex(progname, '/'))
  	  progname = ptr+1;
***************
*** 1677,1682 ****
--- 1801,1820 ----
  			xxargc--;
  			xxargv++;
  		}
+ #ifdef	NEMACS
+ /* 89.3.23 patch by K.Handa: "fkn" -> "fk" */
+ 		if ((xxargc > 1) && (!strcmp (*xxargv, "-kfont") ||
+ 				     !strcmp (*xxargv, "-fk"))) {
+ 			xxargc--;
+ 			xxargv++;
+ 			if (XXWcurrentfont != NULL)
+ 				free(XXWcurrentfont);
+ 			XXWcurrentfont = (char *) xmalloc (strlen (*xxargv)+1);
+ 			strcpy (XXWcurrentfont, *xxargv);
+ 			xxargc--;
+ 			xxargv++;
+ 		}
+ #endif
  		if ((xxargc > 1) && !strcmp (*xxargv, "-wn")) {
  			xxargc--;
  			xxargv++;
***************
*** 1877,1882 ****
--- 2015,2034 ----
  	    strcpy (XXcurrentfont, temp_font);
  	}
  	
+ #ifdef	NEMACS
+ 	if (!XXWcurrentfont)
+ 	{
+ 	    XXWcurrentfont = (char *) xmalloc (strlen (temp_wfont) + 1);
+ 
+ 	    if (!XXWcurrentfont) {
+ 		fprintf (stderr, "Memory allocation failure.\n");
+ 		exit (-150);
+ 	    }
+ 
+ 	    strcpy (XXWcurrentfont, temp_wfont);
+ 	}
+ #endif	NEMACS
+ 	
  
  
  	signal (SIGPIPE, XExitGracefully);
***************
*** 1935,1943 ****
--- 2087,2104 ----
   *  Load a font by name.  Return the font pointer, or NULL if
   *  it can't be loaded.  Do all appropriate calculations.
   */
+ #ifdef	NEMACS
+ #define	XT_CalcForFont(fontname)	_XT_CalcForFont(fontname, 0)
+ #define	XT_CalcForWFont(fontname)	_XT_CalcForFont(fontname, 1)
+ static XFontStruct *
+ _XT_CalcForFont(fontname, WFontSpecify)
+     char  *fontname;
+     int  WFontSpecify;
+ #else
  static XFontStruct *
  XT_CalcForFont(fontname)
      char  *fontname;
+ #endif	NEMACS
  {
      XFontStruct  *fontp;
  
***************
*** 1947,1956 ****
--- 2108,2143 ----
  	return  (XFontStruct *) NULL;
      }
  
+ #ifdef	NEMACS  /* modified by K.Handa 89.12.12 */
+     if (WFontSpecify) {
+       XXWfid = fontp->fid;
+       XXWfonth = fontp->ascent + fontp->descent;
+       XXWfontw = fontp->max_bounds.width;
+       XXWbase = fontp->ascent;
+       XXWul_descent = fontp->descent - 2;
+ /* 89.12.11  patch by K.Handa */
+       XXWhighencoding =  (fontp->min_char_or_byte2 > 0x80);
+ /* end of patch */
+     } else {
+       XXfid = fontp->fid;
+       XXfonth = fontp->ascent + fontp->descent;
+       XXfontw = fontp->max_bounds.width;
+       XXbase = fontp->ascent;
+       XXul_descent = fontp->descent - 2;
+     }
+     if (XXfonth < XXWfonth) XXfonth = XXWfonth;
+     if (XXfontw * 2 < XXWfontw) {
+       XXfontw = (XXWfontw + 1) / 2;
+       XXWfontw = XXfontw * 2;
+     }
+     if (XXbase < XXWbase) XXbase = XXWbase;
+     if (XXul_descent < XXWul_descent) XXul_descent = XXWul_descent;
+ #else
      XXfid = fontp->fid;
      XXfonth = fontp->ascent + fontp->descent;
      XXfontw = fontp->max_bounds.width;
      XXbase = fontp->ascent;
+ #endif	NEMACS
  
      return  fontp;
  }
***************
*** 1958,1965 ****
--- 2145,2170 ----
  
  /* ------------------------------------------------------------
   */
+ #ifdef	NEMACS
+ XNewFont (newname)
+      char *newname;
+ {
+ 	return(_XNewFont(newname, 0));
+ }
+ 
+ XNewWFont (newname)
+      char *newname;
+ {
+ 	return(_XNewFont(newname, 1));
+ }
+ 
+ _XNewFont (newname, WFontSpecify)
+      register char *newname;
+      int WFontSpecify;
+ #else
  XNewFont (newname)
       register char *newname;
+ #endif	NEMACS
  {
  	XFontStruct *temp;
  	BLOCK_INPUT_DECLARE ();
***************
*** 1968,1974 ****
--- 2173,2183 ----
  	XFlush (XXdisplay);
  
  
+ #ifdef	NEMACS
+ 	temp = _XT_CalcForFont(newname, WFontSpecify);
+ #else
  	temp = XT_CalcForFont(newname);
+ #endif	NEMACS
  
  	if (temp == (XFontStruct *) NULL)
  	{
***************
*** 1980,1987 ****
--- 2189,2212 ----
  	XSetFont (XXdisplay, XXgc_rev, XXfid);
  	XSetFont (XXdisplay, XXgc_curs, XXfid);
  
+ #ifdef	NEMACS
+ 	XSetFont (XXdisplay, XXWgc_norm, XXWfid);
+ 	XSetFont (XXdisplay, XXWgc_rev, XXWfid);
+ 	XSetFont (XXdisplay, XXWgc_curs, XXWfid);
+ #endif	NEMACS
+ 
+ #ifdef	NEMACS
+ 	if (WFontSpecify) {
+ 	    XFreeFont (XXdisplay, wfontinfo);
+ 	    wfontinfo = temp;
+ 	} else {
+ 	XFreeFont (XXdisplay, fontinfo);
+ 	fontinfo = temp;
+ 	}
+ #else
  	XFreeFont (XXdisplay, fontinfo);
  	fontinfo = temp;
+ #endif	NEMACS
  
  
  	XSetWindowSize(screen_height, screen_width);
***************
*** 2021,2026 ****
--- 2246,2256 ----
  	XXgc_temp = XXgc_norm;
  	XXgc_norm = XXgc_rev;
  	XXgc_rev = XXgc_temp;
+ #ifdef	NEMACS
+ 	XXWgc_temp = XXWgc_norm;
+ 	XXWgc_norm = XXWgc_rev;
+ 	XXWgc_rev = XXWgc_temp;
+ #endif	NEMACS
  
  	if (!strcmp (mous_color, "white"))
  	  mous_color = "black";
***************
*** 2040,2045 ****
--- 2270,2278 ----
  			curs_color = "white";
  		}
  	XSetState (XXdisplay, XXgc_curs, back, curs, GXinvert, AllPlanes);
+ #ifdef	NEMACS
+ 	XSetState (XXdisplay, XXWgc_curs, back, curs, GXinvert, AllPlanes);
+ #endif	NEMACS
  
  	CursorToggle ();
  	XFlush (XXdisplay);
***************
*** 2317,2322 ****
--- 2550,2561 ----
  	== (XFontStruct *) NULL)
        fatal ("X server unable to find requested font `%s'.\n",
  	     (XXcurrentfont == NULL) ? "(null)" :  XXcurrentfont);
+ #ifdef	NEMACS
+     if ( (wfontinfo = XT_CalcForWFont(XXWcurrentfont))
+ 	== (XFontStruct *) NULL)
+       fatal ("X server unable to find requested font `%s'.\n",
+ 	     (XXWcurrentfont == NULL) ? "(null)" :  XXWcurrentfont);
+ #endif	NEMACS
  
      pr = XGeometry (XXdisplay, 0, desiredwindow, default_window,
  		    XXborder, XXfontw, XXfonth,
***************
*** 2362,2367 ****
--- 2601,2624 ----
      XXgc_curs = XCreateGC(XXdisplay, XXwindow,
  			  GCFont|GCForeground|GCBackground,
  			  &XXgcv);
+ #ifdef	NEMACS
+     XXWgcv.font = XXWfid;
+     XXWgcv.foreground = fore;
+     XXWgcv.background = back; 
+     XXWgc_norm = XCreateGC(XXdisplay, XXwindow,
+ 			  GCFont|GCForeground|GCBackground,
+ 			  &XXWgcv);
+     XXWgcv.foreground = back;
+     XXWgcv.background = fore;
+     XXWgc_rev = XCreateGC(XXdisplay, XXwindow,
+ 			 GCFont|GCForeground|GCBackground,
+ 			 &XXWgcv);
+     XXWgcv.foreground = back;
+     XXWgcv.background = curs;
+     XXWgc_curs = XCreateGC(XXdisplay, XXwindow,
+ 			  GCFont|GCForeground|GCBackground,
+ 			  &XXWgcv);
+ #endif	NEMACS
  
      EmacsCursor = XCreateFontCursor(XXdisplay, XC_left_ptr);
  
***************
*** 2392,2397 ****
--- 2649,2737 ----
      XMapWindow (XXdisplay, XXwindow);
      XFlush (XXdisplay);
  }
+ 
+ #ifdef	NEMACS
+ 
+ /* patch for attribute by K.Handa  89.11.24 */
+ /* original line is
+ XDrawEUC(display, d, gc, gcw, x, y, string, length)
+    and new lines are */
+ XDrawEUC(display, d, gc, gcw, attr, x, y, string, length)
+         unsigned char  *attr;
+ /* end of patch */
+ 	Display	*display;
+ 	Drawable d;
+ 	GC	gc, gcw;
+ 	int	x, y;
+ 	unsigned char	*string;
+ 	int	length;
+ {
+ 	unsigned char	buf[MScreenWidth*2], *q;
+ 	unsigned char	*p = string, *r;
+ 	int	flag;
+ 	int	len;
+ 	int     startx = x;
+ /* patch for attribute by K.Handa  89.11.24, 89.12.12 */
+ 	unsigned char   *a = attr;
+ 	int attribute_bits = *a;
+ 	GC gci, gcwi, gctemp;
+ 	int underline_height = y + XXul_descent;
+ 
+ 	if (gc == XXgc_norm) gci = XXgc_rev, gcwi = XXWgc_rev;
+ 	else if (gc == XXgc_rev) gci = XXgc_norm, gcwi = XXWgc_norm;
+ 	else gci = XXgc_norm, gcwi = XXWgc_norm;
+ /* end of patch */
+ 
+ 	if (length == 0)
+ 		return;
+ 
+ 	q = buf; len = 0;
+ 	flag = *p & 0x80; r = p;
+ 	for ( ; ; ) {
+ 	  if (*p & 0x80) {
+ /* 89.12.11 patch by K.Handa */
+ 	    if (XXWhighencoding) {
+ 	      *q++ = *p++;
+ 	      *q++ = *p++;
+ 	    } else {
+ 	      *q++ = *p++ & 0x7f;
+ 	      *q++ = *p++ & 0x7f;
+ 	    }
+ /* end of patch */
+ 	    len += 2; length -= 2;
+ 	    a += 2;
+ 	  } else {
+ 	    *q++ = *p++;
+ 	    len += 1; length -= 1;
+ 	    a++;
+ 	  }
+ /* patch for attribute by K.Handa  89.11.24, 89.12.12 */
+ /* many lines modified here after */
+ 	  if ((*p & 0x80) != flag || length <= 0 || *a != attribute_bits) {
+ 	    /* change state */
+ 	    if (flag) {		/* was KANJI */
+ 	      gctemp = (attribute_bits & ATTR_INVERSE) ? gcwi : gcw;
+ 	      XDrawImageString16(display,d,gctemp,x,y, (XChar2b *)buf, len/2);
+ 	    } else {
+ 	      gctemp = (attribute_bits & ATTR_INVERSE) ? gci : gc;
+ 	      XDrawImageString(display, d, gctemp, x, y, buf, len);
+ 	    }
+ 	    if (attribute_bits & ATTR_UNDERLINE) {
+ 	      XDrawLine(display, d, gctemp, x, underline_height,
+ 			x + (p - r) * XXfontw - 1, underline_height);
+ 	    }
+ 	    attribute_bits = *a;
+ /* end of patch */
+ 	    x += (p-r) * XXfontw;
+ 	    flag = *p & 0x80;
+ 	    r = p;
+ 	    len = 0; q = buf;
+ 	    if (length <= 0)
+ 	      break;
+ 	  }
+ 	}
+ }
+ #endif	NEMACS
  
  #endif /* HAVE_X_WINDOWS */
  
